freemarker.ext.jython

## Class JythonModel

- java.lang.Object
- - freemarker.ext.jython.JythonModel

All Implemented Interfaces:
  WrapperTemplateModel, AdapterTemplateModel, TemplateBooleanModel, TemplateHashModel, TemplateMethodModel, TemplateMethodModelEx, TemplateModel, TemplateScalarModel

Direct Known Subclasses:
  JythonHashModel, JythonNumberModel, JythonSequenceModel

    public class JythonModel
    extends Object
    implements TemplateBooleanModel, TemplateScalarModel, TemplateHashModel, TemplateMethodModelEx, AdapterTemplateModel, WrapperTemplateModel

Generic model for arbitrary Jython objects.

### Field Summary

Fields
`protected org.python.core.PyObject` `object`
`protected JythonWrapper` `wrapper`

### Fields inherited from interface freemarker.template.TemplateBooleanModel

`FALSE, TRUE`

### Fields inherited from interface freemarker.template.TemplateScalarModel

`EMPTY_STRING`

### Fields inherited from interface freemarker.template.TemplateModel

`NOTHING`

### Constructor Summary

Constructors
Constructor and Description
`JythonModel(org.python.core.PyObject object, JythonWrapper wrapper)`

### Method Summary

All Methods Instance Methods Concrete Methods
`Object` `exec(List arguments)` Executes the method call.
`TemplateModel` `get(String key)` Calls `PyObject.__findattr__(java.lang.String)`, then if it returns null calls `PyObject.__finditem__(java.lang.String)`.
`Object` `getAdaptedObject(Class hint)` Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.
`boolean` `getAsBoolean()` Returns the value of `PyObject.__nonzero__()`.
`String` `getAsString()` Returns the value of `Object.toString()`.
`Object` `getWrappedObject()` Retrieves the original object wrapped by this model.
`boolean` `isEmpty()` Returns `PyObject.__len__()``== 0`.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### object

    protected final org.python.core.PyObject object

#### wrapper

    protected final JythonWrapper wrapper

### Constructor Detail

#### JythonModel

    public JythonModel(org.python.core.PyObject object,
                       JythonWrapper wrapper)

### Method Detail

#### getAsBoolean

    public boolean getAsBoolean()
                         throws TemplateModelException

Returns the value of `PyObject.__nonzero__()`.

Specified by:
  `getAsBoolean` in interface `TemplateBooleanModel`
Returns:
  whether to interpret this object as true or false in a boolean context
Throws:
  `TemplateModelException`

#### getAsString

    public String getAsString()
                       throws TemplateModelException

Returns the value of `Object.toString()`.

Specified by:
  `getAsString` in interface `TemplateScalarModel`
Throws:
  `TemplateModelException`

#### get

    public TemplateModel get(String key)
                      throws TemplateModelException

Calls `PyObject.__findattr__(java.lang.String)`, then if it returns null calls `PyObject.__finditem__(java.lang.String)`. If `JythonWrapper.setAttributesShadowItems(boolean)` was called with `false`, the order of calls is reversed (that is, item lookup takes precedence over attribute lookup).

Specified by:
  `get` in interface `TemplateHashModel`
Parameters:
  `key` - the name by which the `TemplateModel` is identified in the template.
Returns:
  the `TemplateModel` referred to by the key, or null if not found.
Throws:
  `TemplateModelException`

#### isEmpty

    public boolean isEmpty()
                    throws TemplateModelException

Returns `PyObject.__len__()``== 0`.

Specified by:
  `isEmpty` in interface `TemplateHashModel`
Throws:
  `TemplateModelException`

#### exec

    public Object exec(List arguments)
                throws TemplateModelException

Description copied from interface: `TemplateMethodModelEx`
Executes the method call.

Specified by:
  `exec` in interface `TemplateMethodModel`
Specified by:
  `exec` in interface `TemplateMethodModelEx`
Parameters:
  `arguments` - a `List` of `TemplateModel`-s, containing the arguments passed to the method. If the implementation absolutely wants to operate on POJOs, it can use the static utility methods in the `DeepUnwrap` class to easily obtain them. However, unwrapping is not always possible (or not perfectly), and isn't always efficient, so it's recommended to use the original `TemplateModel` value as much as possible.
Returns:
  the return value of the method, or `null`. If the returned value does not implement `TemplateModel`, it will be automatically wrapped using the `environment's object wrapper`.
Throws:
  `TemplateModelException`
See Also:
  `TemplateMethodModel.exec(List)`

#### getAdaptedObject

    public Object getAdaptedObject(Class hint)

Description copied from interface: `AdapterTemplateModel`
Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.

Specified by:
  `getAdaptedObject` in interface `AdapterTemplateModel`
Parameters:
  `hint` - the desired class of the returned value. An implementation should make reasonable effort to retrieve an object of the requested class, but if that is impossible, it must at least return the underlying object as-is. As a minimal requirement, an implementation must always return the exact underlying object when `hint.isInstance(underlyingObject)` holds. When called with `java.lang.Object.class`, it should return a generic Java object (i.e. if the model is wrapping a scripting language object that is further wrapping a Java object, the deepest underlying Java object should be returned).
Returns:
  the underlying object, or its value accommodated for the hint class.

#### getWrappedObject

    public Object getWrappedObject()

Description copied from interface: `WrapperTemplateModel`
Retrieves the original object wrapped by this model.

Specified by:
  `getWrappedObject` in interface `WrapperTemplateModel`